---
layout: markdown_page
title: "Category Strategy - Geo-replication"
description: "Using Geo replications reduces the time it needs to fetch and clone repositories, which increases developer productivity. Learn more here!"
canonical_path: "/direction/geo/geo_replication/"
---

- TOC
{:toc}

## 🌏 Geo-replication

**Last updated**: 2020-05-05

### Introduction and how you can help
* [Overall Strategy](/direction/geo)
* [Roadmap for Geo Replication](https://gitlab.com/groups/gitlab-org/-/roadmap?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo&label_name[]=geo%3A%3Aactive)
* [Maturity: <%= data.categories["geo_replication"].maturity.capitalize %>](/direction/maturity/)
* [Documentation](https://docs.gitlab.com/ee/administration/geo/replication/)
* [Complete Maturity epic](https://gitlab.com/groups/gitlab-org/-/epics/1508)
* [All Epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo)

The Geo-replication category helps distributed developer teams be more
productive. With a single GitLab instance working with large repositories can
take a long time for developers located in different geographies.
Geo-replication provides an easily configurable, read-only mirror (we call it a
Geo node) of a GitLab installation that is complete, accurate, verifiable and
efficient. This is valuable because using Geo reduces the time it needs to
fetch and clone repositories, which increases developer productivity.

Please reach out to Fabian Zimmer, Product Manager for the Geo group
([Email](mailto:fzimmer@gitlab.com)) if you'd like to provide feedback or ask
any questions related to this product category.

This strategy is a work in progress, and everyone can contribute:

 - Please comment and contribute in the linked
 [issues](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo)
 and
 [epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo)
 on this page. Sharing your feedback directly on GitLab.com is the best way to
 contribute to our strategy and vision.

### Current state
Currently, Geo-replication requires a significant investment to be
configured, upgraded and maintained by systems administrators. Not all parts of
GitLab are replicated and there is not as much control over what is replicated
where.

### Where we are headed
Our goal for Geo-replication is to offer the same experience to users,
regardless of their location. In the future, we want our users to be able to
configure Geo within minutes - not hours. We envision Geo-replication to be
fully transparent to users. This means that a developer should not need to
actively decide to use Geo, or select the right Geo node - GitLab should be able
to determine what Geo node should be used to provide the best user experience.
For systems administrators, it should be simple to add, configure and remove new
nodes.

* Pulls and clones of git repositories should be fast everywhere - especially for large repositories.
* Users should not be required to configure geo-replication manually - we should detect the best Geo node automatically.
* Geo-replication should be easy to set-up and configure - new Geo nodes should be added with minimal effort.
* Geo-replication should be fully transparent for users - ideally a user of GitLab does not even notice that they are using a Geo node.
* Geo-replication should allow fine-grained control over what is replicated where - not every project and repository needs to be shared.
* All data types generated by GitLab should be able to be replicated and verified.

### Target audience and experience
<!-- An overview of the personas involved in this category. An overview
of the evolving user journeys as the category progresses through minimal,
viable, complete and lovable maturity levels.-->

#### [Sidney (Systems Administrator)](https://about.gitlab.com/handbook/marketing/product-marketing/roles-personas/#sidney-systems-administrator)
* 🙂 **Minimal** - Sidney is able to configure the Geo-replication setup manually, most commonly used data types are replicated.
* 😊 **Viable** - Sidney is able to configure Geo-replication in a mostly automated fashion. Various Geo-replication tasks (status reports, maintenance etc.) can be performed using the GitLab UI. All customer relevant data types are replicated.
* 😁 **Complete** - Sidney can setup Geo in an automated and fast way (minutes, not hours). A dashboard provides an overview for all relevant Geo tasks.
* 😍 **Lovable** - Sidney can setup Geo in an automated and fast way and everything is configurable from the UI, all nodes appear writable.

#### [Sasha (Software Developer)](https://about.gitlab.com/handbook/marketing/product-marketing/roles-personas/#sasha-software-developer)
* 🙂 **Minimal** - Sasha has to configure Git manually to use Geo. No automatic proxying of request to the primary. WebUI on secondary is not available.
* 😊 **Viable** - Sasha has to configure Git manually but automatic proxying to the primary is possible. WebUI is read-only.
* 😁 **Complete** - Sasha only requires a single URL for all Git operations - the correct Geo node is used automatically.
* 😍 **Lovable** - Sasha can push and pull directly to a Geo node. Everything is read and writable, including the WebUI. The user experience is the same independent of location.

For more information on how we use personas and roles at GitLab, please [click
here](https://about.gitlab.com/handbook/marketing/product-marketing/roles-personas/).

### What's next & why
<!-- This is almost always sourced from the following sections, which describe top
priorities for a few stakeholders. This section must provide a link to an issue
or [epic](https://about.gitlab.com/handbook/product/product-processes/#epics-for-a-single-iteration) for the MVC or first/next iteration in
the category.-->

We are working in parallel on accelerating [how new datatypes
can be added to Geo
nodes](https://about.gitlab.com/direction/geo/disaster_recovery/#building-a-self-service-geo-framework);
this impacts Geo-replication but is part of the [Disaster recovery category](https://about.gitlab.com/direction/geo/disaster_recovery/).
{: .alert .alert-warning}

#### Improving the administrator UI/UX
We have identified many [small usability issues with the Geo Administrator
UI](https://gitlab.com/groups/gitlab-org/-/epics/369) and will start a
comprehensive review of Geo's administrator panel. This includes [generating UX
scorecards](https://gitlab.com/gitlab-org/gitlab-design/issues/731) and also
discovery work to evaluate which specific tasks systems administrators need or
want to perform using the UI. We will then iterate on the UI and add additional
functionalities as needed. Additionally, we will work on refactoring the
frontend code to be in line with our latest design guidelines.

#### Automatically choose the Geo node for the best user experience
Using a Geo node to overcome UX issues (e.g. latency)  requires additional
configuration for software developers, which is cumbersome. Using the secondary 
web interface is a worse user experience than using the primary. A software developer
needs to switch between a primary and secondary frequently, which can be highly confusing and frustrating.

In Q3/Q4 2020, we plan to [automatically choose the best Geo node](https://gitlab.com/groups/gitlab-org/-/epics/1466).
This means that Geo will forward any requests from a secondary to a primary *unless* the user experience can
be significantly improved by using the secondary. This will likely result in the deprecation of the read-only
web interface because requests will be proxied from a secondary to a primary.

### In a year

#### Geo should be easy to install
Installing Geo is highly manual and cumbersome, especially in high-availability
configurations. The Distribution team is working to make [deploying and
configuring Geo nodes
easier](https://gitlab.com/gitlab-org/omnibus-gitlab/issues/4869). The Geo team
will support this effort and in the beginning of 2020, we are going to start
investigating how we can [simplify Geo's
installation](https://gitlab.com/groups/gitlab-org/-/epics/1465).

We also identified that a service discovery
solution could have a huge benefit in helping administrators set up clusters of
Geo nodes. We are currently working to [support Geo on
Kubernetes](https://gitlab.com/groups/gitlab-org/-/epics/944) to give us a
greater understanding of this tool that will help inform us as to the right direction
to take with this proposal. We will [update the service discovery
proposal](https://gitlab.com/gitlab-org/gitlab-ee/issues/8932) when Kubernetes
support is complete.

### What is not planned right now
We are currently not planning on moving away from Postgres as a backend database
in favour of e.g CockroachDB or Google Spanner. This has implications for
multi-mode Geo, but for now we will continue to support PostgreSQL.

#### Multi-mode Geo
Currently, Geo can only officially be operated in one mode -
[Read-Only](#read-only) - where each the database on a Geo secondary is in a
read-only mode. Customer feedback has indicated a desire for additional
operational / running modes, namely making Geo read and writable. We have
explored two POCs
([1](https://gitlab.com/gitlab-org/gitlab-ee/merge_requests/9354),
[2](https://gitlab.com/gitlab-org/gitlab-ee/merge_requests/10309)) and will
revisit this in an effort to move Geo from Complete to Lovable. This is not
expected to start in FY21.


### Maturity plan
<!-- It's important your users know where you're headed next. The maturity plan
section captures this by showing what's required to achieve the next level. The
section should follow this format: -->

This category is currently at the `viable` maturity level, and our next maturity
target is `complete` (see our [definitions of maturity
levels](/direction/maturity/#legend).

You can track the work that will move the category to `complete` in
[this epic](https://gitlab.com/groups/gitlab-org/-/epics/1508).

### Competitive landscape
<!-- The top two or three competitors, and what the next one or two items we should
work on to displace the competitor at customers, ideally discovered through
[customer meetings](https://about.gitlab.com/handbook/product/product-processes/#customer-meetings). We’re not aiming for feature parity
with competitors, and we’re not just looking at the features competitors talk
about, but we’re talking with customers about what they actually use, and
ultimately what they need.-->

The top competitors for Geo-replication are

- [GitHub Enterprise geo-replication](https://help.github.com/en/enterprise/2.17/admin/installation/about-geo-replication)
- [Azure DevOps](https://azure.microsoft.com/en-in/services/devops/)
- [Bitbucket Smart Mirroring](https://confluence.atlassian.com/bitbucket/work-with-bitbucket-smart-mirroring-838427532.html)

#### Feature overview

| Feature  | GitHub  | AzureDevOps  | Bitbucket Smart Mirroring  | GitLab |
|---|---|---|---|---|
| Mirror repositories  | ✅  | ✅  | ✅  | ✅  |
| Active-active replication  | ❌  | N/A  | ❌  | ❌ |
| Selective sync  | N/A  | N/A   | ✅  | ⚠️ |
| UI configuration  | ❌ |  ✅ | N/A  | ⚠️ |
| Kubernetes support  |  ❌ |   ❌ | ❌  | ⚠️ |
| Mirror docker registries  | ❌  |  N/A | ❌  |  ✅ |
| LFS and file upload support  | ✅  | N/A   |  ✅  | ✅  |
| Automatic DNS   |  ✅ | ✅ | ❌  |  ⚠️
| GUI Dashboard   |  ✅ | ✅ | N/A  |  ✅  |
| Request proxying   |  ✅ | N/A | N/A  |  ⚠️   |

 ✅ Fully available
 ⚠️ Partially available
 ❌ Not available
 N/A No information available

### Analyst landscape
We do need to engage with analysts more closely to understand the current landscape better.

### Top customer success/sales issue(s)

* [https://gitlab.com/gitlab-org/gitlab-ee/issues/2870](https://gitlab.com/gitlab-org/gitlab-ee/issues/2870)
* [Active active git replication](https://gitlab.com/gitlab-org/gitlab-ee/issues/1381)

### Top user issues
<!-- This is probably the top popular issue from the category (i.e. the one with the most
thumbs-up), but you may have a different item coming out of customer calls.-->

* [Category issues listed by popularity](https://gitlab.com/groups/gitlab-org/-/issues?label_name%5B%5D=Geo&scope=all&sort=popularity&state=opened&utf8=%E2%9C%93)

### Top internal customer issues/epics
<!-- These are sourced from internal customers wanting to [dogfood](/handbook/values/#dogfooding)
the product.-->

* [Build a scalable, self-service geo-replication and
verification framework](https://gitlab.com/groups/gitlab-org/-/epics/2161)

### Top strategy item(s)

* [Simplify Geo's installation](https://gitlab.com/groups/gitlab-org/-/epics/1465)
